package net.weasel.PaintBucket;

import java.util.ArrayList;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerListener;

public class PaintBucketListener extends PlayerListener
{
	public PaintBucket plugin;
	public Server server;
	
	public PaintBucketListener(PaintBucket instance)
	{
		plugin = instance;
		server = plugin.getServer();
	}

	public void onPlayerInteract( PlayerInteractEvent event )
	{
		Player player = event.getPlayer();
		
		
		if( PaintBucket.isAllowed(player) == true 
		&& PaintBucket.isPaintBucketDisabled(player) == false )
		{
			int paintTypeId = 0;
			
			if( PaintBucket.paintBlocks.containsKey(player) )
				paintTypeId = PaintBucket.paintBlocks.get(player);
			else
			{
				player.sendMessage( ChatColor.BLUE + "Please first set a block type with the " 
				+ ChatColor.YELLOW + "/paintbucket command." );
				player.sendMessage( "(or try " + ChatColor.YELLOW + "/paintbucket disable" 
				+ ChatColor.BLUE + " to use your bucket normally.)" );
				event.setCancelled( true );
				return;
			}

			if( player.getItemInHand().getType() == Material.BUCKET )
			{
				if( event.getAction() == Action.RIGHT_CLICK_BLOCK )
				{
					Block targetBlock = event.getClickedBlock();
					
					if( paintTypeId == targetBlock.getTypeId() )
					{
						event.setCancelled(false);
						return;
					}
					
					if( PaintBucket.blockLists.containsKey(player) )
					{
						if( targetBlock.getTypeId() == PaintBucket.paintBlocks.get(player) )
						{
							
						}
						
						PaintBucket.targetBlocks.put(player, targetBlock.getTypeId() );
						PaintBucket.blockLists.get(player).add( targetBlock.getLocation() );
					}
					else
					{
						ArrayList<Location> newList = new ArrayList<Location>();
						newList.add( targetBlock.getLocation() );

						PaintBucket.targetBlocks.put(player, targetBlock.getTypeId() );
						PaintBucket.blockLists.put( player, newList );
					}
					event.setCancelled( true );
				}
			}
		}
	}
}
